//---------------------------------------------------------------------------
#ifndef Uloha1_mapa_tH
#define Uloha1_mapa_tH
//---------------------------------------------------------------------------

/*
 * 1. Deklarace tridy mapa
 *
 */

#include <vcl.h>

#include "Uloha1_seznam_t.h"
#include "Uloha1_hex_t.h"
#include "Uloha1_misto_t.h"

//===========================1. TRIDA MAPA===================================

class mapa_t {
  TCanvas* canvas;  //implicitni canvas, kam se mapa vykresluje
  //rozmery mapy - dany poctem hexu na vysku a sirku - viz fce ?????_v_pxl()
  int pocet_hexu_na_vysku;
  int pocet_hexu_na_sirku;
  seznam_t<hex_t> hexy;
  seznam_t<misto_t> mista;
  seznam_iterator_t<hex_t> hiter; //iteratory udrzuji info o vybranych objektech
  seznam_iterator_t<misto_t> miter;
public:
//  mapa_t(TCanvas* cc, int vv, int ss, int hh); //NEFUNGUJE - vyzaduje druhou
                                               //verzi specialniho konstruktoru
                                               //u tridy hex_t ta je momentalne
                                               //nefunkcni
  mapa_t(TCanvas* cc, int vv, int ss, const hex_t& hh);
  void oznac(int x, int y); //oznaci objekt mapy
  void vymaz(); //smaze vybrany objekt
  void vloz_misto(int x, int y);
  void vloz_popisek(int x, int y);
  void edituj(); //vyvola Dialog pro vybrany objekt
  void posun_do(int x, int y); //posune vybrany objekt na souradnice x, y
  void odoznac(); //odoznaci pripadne vybrane objekty
  void kresli_vse(TCanvas* p_c) const; //kresli vsechny objekty na mape

  //ostatni
  int vyska_v_pxl() { return (pocet_hexu_na_vysku + 1.5) * hexy.zacatek()->vyska; }
  int sirka_v_pxl() { return (pocet_hexu_na_sirku + 1) * hexy.zacatek()->sirka * 0.75; }
};

#endif  //Uloha1_mapa_tH
