//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//--------------------------------------------------------------------------
#include "Uloha1_MainForm.h"
#include "Uloha1_ChildForm.h"
#include "Uloha1_MapaDlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
  Close();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Tile1Click(TObject *Sender)
{
  Tile();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::Cascade1Click(TObject *Sender)
{
  Cascade();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::New1Click(TObject *Sender)
{
  if (MapaDlg->ShowModal() == mrOk) {
    //vytvoreni noveho child okna
    TChildForm* NewChild = new TChildForm(this);
    NewChild->Caption = "Mapa " + String(MDIChildCount);
    //pridani odkazu na okno do Menu Window
    TMenuItem* NewItem = new TMenuItem(MainMenu);
    Window1->Add(NewItem);
    NewItem->Caption = NewChild->Caption;
  }
}
//---------------------------------------------------------------------------

/*
//moje udalost OnClick pro nove vytvorene polozky menu Window
void __fastcall (__closure *TChildForm::MujEventHandler)(TObject *Sender)
{
}
//---------------------------------------------------------------------------
*/

void __fastcall TMainForm::Close1Click(TObject *Sender)
{
  if (MDIChildCount > 0) {
    //odstraneni TMenuItem z Menu Window
/*
    TMenuItem* Item = N6; //nastaveni na posledni nepridany TMenuItem v menu Window
    Application->MessageBox("N6", Item->Caption.c_str(), MB_OK);
    for (int i = N6->MenuIndex; i < Window1->Count; ++i) {
      if (Item->Caption == ActiveMDIChild->Caption) break;
    }
    Application->MessageBox("N6", Item->Caption.c_str(), MB_OK);
    Window1->Remove(Item);
*/
    //zavreni aktualniho okna
    ActiveMDIChild->Close();
  }
}
//--------------------------------------------------------------------------

void __fastcall TMainForm::Tools1Click(TObject *Sender)
{
  if (Tools1->Checked) {
    Tools1->Checked = false;
    ToolBar->Hide();
  }
  else {
    Tools1->Checked = true;
    ToolBar->Show();
  }

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SipkaClick(TObject *Sender)
{
  if (Sipka->Down) pozadavek_uziv = OZNAC;
  else pozadavek_uziv = ZADNY;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::VezClick(TObject *Sender)
{
  if (Vez->Down) pozadavek_uziv = VLOZ_MISTO;
  else pozadavek_uziv = ZADNY;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::VymazClick(TObject *Sender)
{
  //tohle je jedina vyjimka z pravidla, ze metody tridy mapa jsou volany
  //v udalosti TChildForm::Image::OnMoudeDown
  //pro vesti pohodlnost uzivatele se objekt rusi hned tady (aby navic nemusel
  //jeste klikat na mapu)
  if (Vymaz->Down) {
    pozadavek_uziv = VYMAZ;
    ((TChildForm*) ActiveMDIChild)->mapa->vymaz();
  }
  else pozadavek_uziv = ZADNY;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PopisekClick(TObject *Sender)
{
  if (Popisek->Down) pozadavek_uziv = VLOZ_POPISEK;
  else pozadavek_uziv = ZADNY;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Redraw1Click(TObject *Sender)
{
  if (MDIChildCount > 0)
    ((TChildForm*) ActiveMDIChild)->mapa->kresli_vse(((TChildForm*) ActiveMDIChild)->Image->Picture->Bitmap->Canvas);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OnHint(TObject* Sender)
{
  StatusBar->SimpleText = Application->Hint;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  Application->ShowHint = true;
  Application->OnHint = this->OnHint;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::SaveAs1Click(TObject *Sender)
{
  if (MDIChildCount > 0) {
    if (SaveDlg->Execute()) {
      ((TChildForm*) ActiveMDIChild)->Image->Picture->SaveToFile(SaveDlg->FileName);
    }
  }
}
//---------------------------------------------------------------------------

