#include<conio.h>
#include<graphics.h>
#include<iostream.h>

void opengraph();        //a function declared in main()

// this program illustrates the concept of multiple inheritance.
// a new class input_xy is used to allow the user to input the
// co-ordinates of a point. input_xy has been defined as a seperate
// class because if it was included in the pixel class then
// pixel would become large.

class point
{
protected:
int x,y;

public:
point() {x=0;y=0;}      // constructor zeroises x,y

void locate_point(int xin, int yin)  // assign point from input
{x=xin;y=yin;}

};

class input_xy
{
public:
int xin,yin;

public:
void keyboard();
};

void input_xy::keyboard()
{
gotoxy(20,1);            // position text on screen
cout << "Please enter x co-ordinate";
cin >> xin;
gotoxy(20,2);
cout << "Please enter y co-ordinate";
cin >> xin;
};

class pixel: public point, public input_xy
	     // class pixel inherits from class point and class input_xy
{            // class pixel can use data and member functions of
	     // class point and class input_xy.
public:
void request_coords()   // ask the user for co-ordinates
{
input_xy::keyboard();    // input co-ordinates from keyboard
point::locate_point(xin,yin); // assign x and y
}

void show()
{
// etc.
}

void hide()
{
// etc.
}

void move()
{
// etc.
}


};



void main()
{
void opengraph();
point apoint;       // calls point constructor to zeroise x,y

pixel apixel;        // no constructor used for pixel.
		    // Object apixel is created from class pixel
apixel.request_coords();  // ask the user for co-ordinates.
apixel.show();
getch();
apixel.hide();
getch();
closegraph();
}

void opengraph()
{
int graphdriver=DETECT,graphmode;
initgraph(&graphdriver,&graphmode,"c:\\tc\\bgi");
}

