//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------
#include "Uloha1_MapaDlg.h"
#include "Uloha1_hex_t.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TMapaDlg *MapaDlg;

//---------------------------------------------------------------------
__fastcall TMapaDlg::TMapaDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}

//---------------------------------------------------------------------
void __fastcall TMapaDlg::OKBtnClick(TObject *Sender)
{
  ModalResult = mrOk;
}

//---------------------------------------------------------------------------
void __fastcall TMapaDlg::CancelBtnClick(TObject *Sender)
{
  ModalResult = mrCancel;
}

//---------------------------------------------------------------------------
void __fastcall TMapaDlg::FormDeactivate(TObject *Sender)
{
  ActiveControl = OKBtn;
}

//----------------------------------------------------------------------------
void __fastcall TMapaDlg::FormCreate(TObject *Sender)
{
  Image->Picture->Bitmap->Height = Image->Height;
  Image->Picture->Bitmap->Width = Image->Width;
}
//---------------------------------------------------------------------------

void __fastcall TMapaDlg::HexEditChange(TObject *Sender)
{
  //vymaz stareho hexu
  Image->Picture->Bitmap->Canvas->Brush->Color = clWhite; //nastaveni barvy
  Image->Picture->Bitmap->Canvas->FillRect(Image->Picture->Bitmap->Canvas->ClipRect);
  //prekresleni hexu v komponente NewDlg->Image
  for (int i = 1; i <= HexEdit->Text.Length(); ++i) {
    if (HexEdit->Text[i] < '0' || HexEdit->Text[i] > '9') {
      Application->MessageBox("Spatne zadani! Pouziji prednastavenou hodnotu.", "Upozorneni", MB_OK);
      HexEdit->Text = "30";
      break;
    }
  }
  if (HexEdit->Text.Length() == 0) {
    Application->MessageBox("Spatne zadani! Pouziji prednastavenou hodnotu.", "Upozorneni", MB_OK);
    HexEdit->Text = "30";
  }
  hex_t hex(Image->Height / 2, Image->Width / 2, HexEdit->Text.ToInt());
  hex.kresli(Image->Picture->Bitmap->Canvas);
}
//---------------------------------------------------------------------------



void __fastcall TMapaDlg::BitBtn1Click(TObject *Sender)
{
  ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TMapaDlg::BitBtn2Click(TObject *Sender)
{
  ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

void __fastcall TMapaDlg::FormActivate(TObject *Sender)
{
  VyskaEdit->Text = "10";
  SirkaEdit->Text = "10";
  HexEdit->Text = "30";
  //zobrazeni default hexu
  hex_t hex(Image->Height / 2, Image->Width / 2, HexEdit->Text.ToInt());
  hex.kresli(Image->Picture->Bitmap->Canvas);
}
//---------------------------------------------------------------------------

