//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "Uloha1_ChildForm.h"
#include "Uloha1_MapaDlg.h"
#include "Uloha1_pozadavek_uziv_t.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TChildForm *ChildForm;
//---------------------------------------------------------------------------
__fastcall TChildForm::TChildForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TChildForm::FormCreate(TObject *Sender)
{
  //vytvoreni instance mapa
  mapa = new mapa_t(this->Image->Picture->Bitmap->Canvas,
         MapaDlg->VyskaEdit->Text.ToInt(),
         MapaDlg->SirkaEdit->Text.ToInt(),
         hex_t(0, 0, MapaDlg->HexEdit->Text.ToInt()));
  //nasatveni spravne velikosti Bitmapy (a Canvasu)
  int pom1 = mapa->vyska_v_pxl();
  int pom2 = mapa->sirka_v_pxl();
  ClientHeight = pom1;
  ClientWidth = pom2;
  Image->Picture->Bitmap->Height = pom1;
  Image->Picture->Bitmap->Width = pom2;
  //zobrazeni maoy
  mapa->kresli_vse(this->Image->Picture->Bitmap->Canvas);
}
//---------------------------------------------------------------------------


void __fastcall TChildForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TChildForm::ImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Button == mbLeft) {
    switch (pozadavek_uziv) {
      case ZADNY:
        mapa->odoznac();
      break;

      case OZNAC:
        mapa->oznac(X, Y);
      break;

      case VYMAZ:
        //mapa->vymaz(); - je volano pro vetsi pohodli uzivatele odjinud
      break;

      case VLOZ_POPISEK:
        Application->MessageBox("V teto verzi bohuzel nefunguje", "Upozorneni", MB_OK);
        //mapa->vloz_popisek(X, Y); NEFUNGUJE
      break;

      case VLOZ_MISTO:
        mapa->vloz_misto(X, Y);
      break;

      default:
      break;
    } //konec switch (pozadavek_uziv)
  } //konec if (Button == mbLeft)
}
//---------------------------------------------------------------------------

void __fastcall TChildForm::ImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  //...
}
//---------------------------------------------------------------------------


